.select {
  @extend .context;

  max-width: 360px;
  display: flex;
  flex-direction: column;
}

.select__search {
  flex: 0 0;
  position: relative;
  border-bottom: 1px solid $color-neutral-200;

  @include flex-align-items();
}

.select__search-icon {
  color: $color-neutral-300;
  padding: 0 12px;
  font-size: 18px;
}

.select__search-input {
  display: block;
  width: 100%;
  border: none;
  padding: 0 12px 0 0;
  border-top-left-radius: 6px;
  border-top-right-radius: 6px;

  @include fixed-height(36px, 14px);
}

.select__items {
  position: relative;
  list-style: none;
  padding: 0;
  margin: 0;
  min-height: 0;
  max-height: (4 * 36px) + 20px; // we show max 4 items
  // note that the value is `scroll` and not `auto` because it depends on the
  // v-auto-overflow-scroll directive.
  overflow-y: scroll;

  &::before,
  &::after {
    content: '';
    display: block;
    height: 10px;
    width: 100%;
  }

  // This class can be set if the max-height is managed by a container element.
  &.select__items--no-max-height {
    max-height: none;
  }

  ul {
    list-style: none;
    margin: 0;
    padding: 0;
  }
}

.select__items--empty {
  padding: 20px 10px;
  white-space: normal;
  text-align: center;
  color: $color-neutral-500;
}

.select__items-loading {
  position: relative;
  height: 32px;

  &::after {
    content: '';
    margin-top: -7px;
    margin-left: -7px;

    @include loading(14px);
    @include absolute(50%, auto, 0, 50%);
  }
}

.select__item-label {
  color: $color-neutral-600;
  margin: 10px 0 10px 10px;
  font-size: 14px;

  li:first-child & {
    margin-top: 0;
  }
}

%select__item-size {
  @include fixed-height(32px, 14px);
}

.select__item-active-icon {
  text-align: center;
  color: $palette-green-600;
  position: absolute;
  top: 8px;
  right: 5px;
  font-size: 17px;
  display: none;
}

.select__item {
  position: relative;
  margin: 0 8px 4px 8px;
  padding: 0 32px 0 10px;
  user-select: none;
  @include rounded($rounded);

  &.select__item--has-notification {
    padding-right: 48px;
  }

  &:last-child {
    margin-bottom: 0;
  }

  &:hover {
    background-color: $color-neutral-100;
  }

  &--selected {
    background-color: $color-primary-100;
  }

  &--indented {
    margin-left: 20px;
  }

  &.select__item--loading::before {
    content: ' ';

    @include loading(14px);
    @include absolute(9px, 9px, auto, auto);
  }

  &.active {
    background-color: $color-primary-100;

    .select__item-active-icon {
      display: block;
    }

    &:not(.select__item--no-options):hover {
      .select__item-active-icon {
        display: none;
      }
    }
  }

  &.disabled {
    background-color: transparent;

    &:hover {
      background-color: transparent;
    }
  }
}

.select__item-link {
  display: block;
  color: $color-neutral-900;

  &:hover {
    text-decoration: none;
  }

  .select__item.disabled & {
    color: $color-neutral-400;

    &:hover {
      cursor: inherit;
    }
  }
}

.select__item-name {
  display: flex;
  align-items: center;

  @extend %ellipsis;
  @extend %select__item-size;

  span:first-child {
    @extend %ellipsis;
  }
}

.select__item-name-text {
  @extend %ellipsis;
}

.select__item-icon {
  margin-right: 6px;
  font-size: 16px;
}

.select__item-image {
  max-width: 15px;
  max-height: 15px;
  margin-right: 6px;
}

.select__item-description {
  font-size: 11px;
  margin-right: -32px;
  line-height: 140%;
  color: $color-neutral-600;
  padding-bottom: 6px;
  padding-right: 10px;
  white-space: normal;
}

.select__item-options {
  @extend %select__item-size;

  display: none;
  text-align: center;
  width: 32px;
  color: $color-neutral-600;
  font-size: 17px;

  @include absolute(0, 0, auto, auto);

  &:hover {
    color: $color-neutral-800;
  }

  :not(.select__item--loading):not(.select__item--no-options):hover > & {
    display: block;
  }
}

.select__description {
  padding-bottom: 14px;
  text-align: center;
}

.select__footer {
  flex: 0 0;
  border-top: 1px solid $color-neutral-200;
}

.select__footer-button {
  position: relative;
  display: block;
  padding: 0 12px;
  color: $color-neutral-600;
  user-select: none;
  border-bottom-left-radius: 2px;
  border-bottom-right-radius: 2px;

  @include fixed-height(36px, 14px);
  @include flex-align-items(6px);

  &:hover {
    background-color: $color-neutral-100;
    text-decoration: none;
  }

  &.button--loading {
    background-color: $color-neutral-200;
  }
}

.select__footer-create {
  display: flex;
  flex-wrap: wrap;
  padding: 8px 12px 4px 12px;
}

.select__footer-create-link {
  position: relative;
  width: calc(50% - 10px);
  color: $color-neutral-900;
  padding: 0 10px;
  margin-bottom: 4px;
  min-width: 0;
  line-height: 26px;
  font-size: 13px;
  @include rounded($rounded);
  @include flex-align-items(4px);

  &:only-child {
    width: 100%;
    flex: unset;
    margin-right: unset !important;
    padding-left: 6px;
  }

  &:nth-child(2n + 1) {
    margin-right: 20px;
  }

  &:hover {
    text-decoration: none;
  }

  &:not(.select__footer-create-link--disabled):hover {
    text-decoration: none;
    background-color: $color-neutral-100;
  }
}

.select__footer-create-link-icon {
  color: $color-neutral-600;
  font-size: 14px;
  margin-left: auto;
}

.select__footer-create-icon {
  color: $color-neutral-600;
  margin-right: 4px;
  font-size: 14px;
}
